Overview | Package | Class | Use | Tree | Deprecated | Index | Help
|  | BEA Systems, Inc.
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.connecterra.ale.dynamicconfig.api
Interface PluginMeta

    public interface PluginMeta

Models a plugin type in the edge server. This contains:

- The role or group of the plugin: This information is used by the plugin framework to route requests to the appropriate object that manages plugins within that role.
- The class name of the plugin: This is used by the framework to instantiate a plugin.
- Key name of the plugin: This must be unique across all `PluginMeta`s in a role and is used to identify the type of the plugin.
- Description of the plugin's configuration parameters.

Nested Class Summary
`static interface` | `PluginMeta.Role` Plugin roles supported by the configuration framework.

Method Summary
`void` | `addParameterMeta(PluginParameterMeta parameterMeta)` Adds a configuration parameter description to the list of supported by this plugin type.
`String` | `getDescription()` Returns a short description of the plugin type that this PluginMeta represents.
`String` | `getDisplayName()` Returns the display name of this PluginMeta.
`String` | `getKeyName()` Returns key name that uniquely identifies this PluginMeta within its role.
`PluginParameterMeta` | `getParameterMeta(String keyName)` Returns the configuration parameter description for the given parameter key name.
`List` | `getParameterMetaList()` Returns a list of `PluginParameterMeta` representing the configuration parameters supported by this plugin type.
`String` | `getRole()` Returns the role or group to which this PluginMeta belongs.
`void` | `setDescription(String description)` Sets the short description of the plugin type that this PluginMeta represents.
`void` | `setParameterMetaList(List parameterMetaList)` Sets the configuration parameter descriptions for this plugin type.

Method Detail

### getRole

    String getRole()

  Returns the role or group to which this PluginMeta belongs. This information is used by the configuration framework to route requests to the approprate object that manages plugins in that role.

  Returns:
    the role to which this PluginMeta belongs

### getKeyName

    String getKeyName()

  Returns key name that uniquely identifies this PluginMeta within its role.

  Returns:
    the key name uniquely identifies the PluginMeta within its role

### getDisplayName

    String getDisplayName()

  Returns the display name of this PluginMeta. This should be an internationalized string. This may be used to represent the plugin type in GUIs and such.

  Returns:
    the display name of this PluginMeta

### getDescription

    String getDescription()

  Returns a short description of the plugin type that this PluginMeta represents.

  Returns:
    a short description of the plugin type that this PluginMeta represents

### setDescription

    void setDescription(String description)

  Sets the short description of the plugin type that this PluginMeta represents. This should be an internationalized string. This may be used to provide more information to users; for example, as tooltips in GUIs.

  Parameters:
    `description` - short description of the plugin type that this PluginMeta represents

### getParameterMetaList

    List getParameterMetaList()

  Returns a list of `PluginParameterMeta` representing the configuration parameters supported by this plugin type. The configuration parameters may be in a nested hierarchy, in which case, the corresponding PluginParameterMeta would represent a parameter group.

  Returns:
    list of `PluginParameterMeta` representing the configuration parameters supported by the plugin type

### setParameterMetaList

    void setParameterMetaList(List parameterMetaList)

  Sets the configuration parameter descriptions for this plugin type.

  Parameters:
    `parameterMetaList` - the list of `PluginParameterMeta` representing the configuration parameters

### addParameterMeta

    void addParameterMeta(PluginParameterMeta parameterMeta)

  Adds a configuration parameter description to the list of supported by this plugin type. The new description will be added as the last element in the list supported by this.

  Parameters:
    `parameterMeta` - the `PluginParameterMeta` representing the configuration parameter that is to be added to the plugin type's supported list

### getParameterMeta

    PluginParameterMeta getParameterMeta(String keyName)
                                         throws NoSuchNameException

  Returns the configuration parameter description for the given parameter key name. This method only looks at PluginParameterMetas that are direct children of this PluginMeta; it will not match the given key with the key names of the descendants that are not direct children of this PluginMeta.

  Parameters:
    `keyName` - the key name of the parameter whose description is to be found
  Returns:
    `PluginParameterMeta` representing the configuration parameter
  Throws:
    `NoSuchNameException` - If the plugin type does not support configuration parameter with the specified key name

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Documentation is available at ${DOCSWEBROOT} Copyright 2007 BEA Systems Inc.
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD